# -*- coding: utf-8 -*-
"""
Created on Fri Nov 29 17:51:28 2019

@author: Cytomic
"""

#utiliza la librería requests para conectar con el servidor OAuth
import requests
from requests.auth import HTTPBasicAuth

#################################################
# Obtencion del token OAuth de acceso y refresco#
#################################################

#establece el client_id, client_secret, username, password y scope
client_id = 'aaf1461b714646a8a1df9665'
client_secret = 'YaDzUdXW-HYbJPCivXYaAFhJDFiNe5x0mI4'
username = '7e0aa013282249ed15a08f84d'
password = 'jEshWDjjS2ho5dtxL3C38zwVXmy8iCzMxxUe362CfUwz0eAKXRdlz9uOuVzFp3g'
grant_type = 'password'
token_url = 'https://auth.pandasecurity.com/oauth/token'
scope = 'orion.api'
headers = {
    'Content-Type': 'application/x-www-form-urlencoded',
}

#configura el cuerpo del mensaje HTTP. Las credenciales del client_id y client_secrent se establecen en las cabeceras del mensaje
body = {
    'username': username,
    'password': password,
    'scope': scope,
    'grant_type': 'password'
}
#codifica el client_id y client_password en base64 y lanza la petición HTTPs
r = requests.post(token_url, auth=HTTPBasicAuth(client_id, client_secret), headers=headers, data=body, verify=False)

#si no hay errores convierte el cuerpo de la respuesta en un JSON para facilitar el acceso al token de acceso y refresco
if r.status_code==200:
    data = r.json()
    #carga el token de acceso y de refresco en las variables
    token_access=data['access_token']
    token_refresh=data['refresh_token']
    
#llamada de ejemplo a la API de alertas
#establece los parámetros necesarios para la llamada
alert_from='1572595090000'   #desde 1/11/2019
alert_to='1575187090000'     #hasta 1/12/2019

#prepara la cabecera HTTP con el token de acceso para lanzar la llamada a la API
h_request = {
    'Authorization': f'Bearer {token_access}',
    'Accept': 'application/json'
}

url_alert = f'https://api.cytomic.ai/api/v1/applications/alerts/{alert_from}/{alert_to}'
r = requests.get(url_alert, headers=h_request, verify=False)

#una vez autenticado comprueba en cada llamada si el token de acceso caducó
if (r.status_code==401): 
    body_refresh = {
        'grant_type':'refresh_token',
        'refresh_token':token_refresh,
        'client_id':client_id,
        'client_secret':client_secret,
        }
    #pide el nuevo token de acceso y refresco
    r = requests.post(token_url, headers=headers, data=body_refresh, verify=False)
    data = r.json()
    #actualiza las variables con el nuevo token de acceso y refresco
    token_access=data['access_token']
    token_refresh=data['refresh_token']

###########################################
#Llamadas de ejemplo a las APIs de Orion #
###########################################

###########################
#Llamada a la API de IoCs#
###########################
#tipo de IOC
iocType='IPIoc'
#datos de los IOCs
ioc_data=[{'ip':'192.168.0.1'},{'ip':'192.168.0.2'},{'ip':'192.168.0.3'}]
#cabeceras para la llamada a la API incluyendo el token de acceso
h_request_ioc = {
        'Authorization': f'Bearer {token_access}',
        'Accept': 'application/json',
        'Content-Type': 'application/json-patch+json'
}

#Objetivo: cargar en el servidor 3 IoCS de tipo IP (IPIoC) con tiempo de caducidad de 10 días
#número de días
days='10'
#activar búsqueda retrospectiva
retrospective=True
#url de la llamada 
url_ioc_add = f'https://api.cytomic.ai/api/v1/applications/iocs/{iocType}?ttlDays={days}&retrospetive={retrospective}'
#devuelve un json con el número de IoCs cargados con éxito
r = requests.post(url_ioc_add, headers=h_request_ioc, json=ioc_data, verify=False)
ioc_add=r.json()

#Objetivo: comprobar los IOCs cargados en la plataforma
#url de la llamada 
url_ioc_list = f'https://api.cytomic.ai/api/v1/applications/iocs/{iocType}/getter/'
r = requests.post(url_ioc_list, headers=h_request_ioc, json=ioc_data, verify=False)
#devuelve un JSON con la definición de los IOCs cargados del tipo indicado y su fecha de carga
iocs_list=r.json()

#Objetivo: inicia una búsqueda retrospectiva de una lista de IOCs
#url de la llamada 
url_ioc_search = f'https://api.cytomic.ai/api/v1/applications/iocs/{iocType}/retrospectivesearcher/'
r = requests.post(url_ioc_search, headers=h_request_ioc, json=ioc_data, verify=False)
#devuelve una lista de jsons con los IOCs encontrados en el parque del cliente
iocs_found=r.json()

#Objetivo: borra los IoCs previamente cargados
#url de la llamada 
url_ioc_del = f'https://api.cytomic.ai/api/v1/applications/iocs/{iocType}/eraser/'
#devuelve un JSON con el número de IoCs borrados con éxito
r = requests.post(url_ioc_del, headers=h_request_ioc, json=ioc_data, verify=False)
ioc_del=r.json()

##################################
#Llamada a la API de conocimiento#
##################################
#cabeceras para la llamada a la API incluyendo el token de acceso
h_request_know = {
    'Authorization': f'Bearer {token_access}',
    'Accept': 'application/json'
}

#Objetivo: obtener información de un md5
#md5 del fichero
md5='6cff0673ce2002a2fe2218642605187a'
#url de la llamada 
url_md5_info = f'https://api.cytomic.ai/api/v1/applications/forensics/md5/{md5}/info'
r = requests.get(url_md5_info, headers=h_request_know, verify=False)
#devuelve un JSON con informacion del fichero
file=r.json()

#Objetivo: obtiene ua lista de equipos que han visto el md5
#url de la llamada 
url_computers = f'https://api.cytomic.ai/api/v1/applications/forensics/md5/{md5}/muids'
r = requests.get(url_computers, headers=h_request_know, verify=False)
#devuelve una lista de jsons con información de cada equipo
computers=r.json()

#Objetivo: obtener informacion extendida de cada equipo que vio el md5
#para cada equipo se extrae el muid del JSON y se llama a la API de información extendida.
for computer in computers:
    #muid del equipo
    muid=computer['muid']
    #url de la llamada 
    url_computers_info = f'https://api.cytomic.ai/api/v1/applications/forensics/muid/{muid}/info'
    r = requests.get(url_computers_info, headers=h_request, verify=False)    
    #devuelve un JSON con información del equipo
    computer_info=r.json()
    
##############################
# Llamada a la API de alertas#
##############################
#cabeceras para la llamada a la API incluyendo el token de acceso.
h_request_alert = {
    'Authorization': f'Bearer {token_access}',
    'Accept': 'application/json'
}
#fecha de inicio, fecha de final y criterio de filtrado
alert_from='1572595090000'
alert_to='1575187090000'
state='Pending'

#Objetivo: obtener el listado de alerta entre dos fechas que no han sido asignadas a un caso
#url de la llamada 
url_alert = f'https://api.cytomic.ai/api/v1/applications/alerts/{alert_from}/{alert_to}?statuses={state}'
r = requests.get(url_alert, headers=h_request_alert, verify=False)
#devuelve una lista de JSONs con información de cada alerta
alerts=r.json()

##################################
# Llamadas a la API de resolucion#
##################################
#cabeceras para la llamada a la API incluyendo el token de acceso
h_request_remediation = {
        'Authorization': f'Bearer {token_access}',
        'Accept': 'application/json',
        'Content-Type': 'application/json-patch+json'
}
#JSON con la lista de muids
muids_data={'muids':['3333-4444','5555-6666']}

#Objetivo: aisla una lista de equipos
#url de la llamada 
url_isolate = f'https://api.cytomic.ai/api/v1/applications/remediations/muids/isolate'
r = requests.post(url_isolate, headers=h_request_remediation, json=muids_data, verify=False)
#devuelve un JSON con el resultado de la operación
isolate=r.json()

#Objetivo: retira el estado de aislamiento de una lista de equipos
#url de la llamada 
url_deisolate = f'https://api.cytomic.ai/api/v1/applications/remediations/muids/deisolate'
r = requests.post(url_deisolate, headers=h_request_remediation, json=muids_data, verify=False)
#devuelve un JSON con el resultado de la operación
deisolate=r.json()

#Objetivo: reinicia una lista de equipos
#url de la llamada 
url_reboot = f'https://api.cytomic.ai/api/v1/applications/remediations/muids/reboot'
r = requests.post(url_reboot, headers=h_request_remediation, json=muids_data, verify=False)
#devuelve un JSON con el resultado de la operación
reboot=r.json()